local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('asm_sockios')
local defs = {
    SOL_SOCKET = '1',
    SO_DEBUG = '1',
    SO_REUSEADDR = '2',
    SO_TYPE = '3',
    SO_ERROR = '4',
    SO_DONTROUTE = '5',
    SO_BROADCAST = '6',
    SO_SNDBUF = '7',
    SO_RCVBUF = '8',
    SO_SNDBUFFORCE = '32',
    SO_RCVBUFFORCE = '33',
    SO_KEEPALIVE = '9',
    SO_OOBINLINE = '10',
    SO_NO_CHECK = '11',
    SO_PRIORITY = '12',
    SO_LINGER = '13',
    SO_BSDCOMPAT = '14',
    SO_REUSEPORT = '15',
    SO_RCVLOWAT = '16',
    SO_SNDLOWAT = '17',
    SO_RCVTIMEO = '18',
    SO_SNDTIMEO = '19',
    SO_PASSCRED = '20',
    SO_PEERCRED = '21',
    SO_SECURITY_AUTHENTICATION = '22',
    SO_SECURITY_ENCRYPTION_TRANSPORT = '23',
    SO_SECURITY_ENCRYPTION_NETWORK = '24',
    SO_BINDTODEVICE = '25',
    SO_ATTACH_FILTER = '26',
    SO_DETACH_FILTER = '27',
    SO_GET_FILTER = '26',
    SO_PEERNAME = '28',
    SO_TIMESTAMP = '29',
    SCM_TIMESTAMP = '29',
    SO_ACCEPTCONN = '30',
    SO_PEERSEC = '31',
    SO_PASSSEC = '34',
    SO_TIMESTAMPNS = '35',
    SCM_TIMESTAMPNS = '35',
    SO_MARK = '36',
    SO_TIMESTAMPING = '37',
    SCM_TIMESTAMPING = '37',
    SO_PROTOCOL = '38',
    SO_DOMAIN = '39',
    SO_RXQ_OVFL = '40',
    SO_WIFI_STATUS = '41',
    SCM_WIFI_STATUS = '41',
    SO_PEEK_OFF = '42',
    SO_NOFCS = '43',
    SO_LOCK_FILTER = '44',
    SO_SELECT_ERR_QUEUE = '45',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

